/*
	Ariad V0.0.0.8
	Ariad (AutoRun.Inf Access Denied) is a minifilter blocking access to \autorun.inf on USB stics

	Based on WDK minifilter examples
	Source code put in public domain by Didier Stevens, no Copyright
	https://DidierStevens.com
	Use at your own risk. It's beta software running inside the kernel
	
	28/01/2009 21:36:30 AriadPreCreate
	30/01/2009 21:36:30 Removed AriadPostCreate prototype
	31/01/2009 12:08:40 AriadPreSetInformation
	2009/02/09: registry, instance context
	2009/02/10: AllowDrives, SETTINGS_READONLY, SETTINGS_NOFILEEXECUTE
	2009/02/11: Time-based exception
	2009/11/04: V0.0.0.7 ..\common\ariad.h
*/
#ifndef __ARIAD_H__
#define __ARIAD_H__

#include "..\common\ariad.h"

typedef struct _ARIAD_DATA {
	PFLT_FILTER Filter;
	HANDLE hDriverRegKey;
	ULONG ulSettings; // AABBCCDD: A network, B disk, C cd-rom, D removable
	                  // AA: 01 autorun.inf 02 executables 04 block access
	int aiAllowDrives[26];
	__int64 iExceptionTime;
} ARIAD_DATA, *PARIAD_DATA;

extern ARIAD_DATA AriadData;

#define ARIAD_INSTANCE_CONTEXT_TAG 'cIxC'

typedef struct _ARIAD_INSTANCE_CONTEXT {
	unsigned char ucFlags;
} ARIAD_INSTANCE_CONTEXT, *PARIAD_INSTANCE_CONTEXT;

#define ARIAD_INSTANCE_CONTEXT_SIZE sizeof(ARIAD_INSTANCE_CONTEXT)

NTSTATUS DriverEntry(__in PDRIVER_OBJECT DriverObject, __in PUNICODE_STRING RegistryPath);
NTSTATUS AriadUnload(__in FLT_FILTER_UNLOAD_FLAGS Flags);
NTSTATUS AriadQueryTeardown(__in PCFLT_RELATED_OBJECTS FltObjects, __in FLT_INSTANCE_QUERY_TEARDOWN_FLAGS Flags);
FLT_PREOP_CALLBACK_STATUS AriadPreCreate(__inout PFLT_CALLBACK_DATA Data, __in PCFLT_RELATED_OBJECTS FltObjects, __deref_out_opt PVOID *CompletionContext);
FLT_PREOP_CALLBACK_STATUS AriadPreSetInformation(__inout PFLT_CALLBACK_DATA Data, __in PCFLT_RELATED_OBJECTS FltObjects, __deref_out_opt PVOID *CompletionContext);
NTSTATUS AriadInstanceSetup(__in PCFLT_RELATED_OBJECTS FltObjects, __in FLT_INSTANCE_SETUP_FLAGS Flags, __in DEVICE_TYPE VolumeDeviceType, __in FLT_FILESYSTEM_TYPE VolumeFilesystemType);
VOID ReadRegistrySettings(__in PUNICODE_STRING RegistryPath);
VOID AriadContextCleanup(__in PFLT_CONTEXT Context, __in FLT_CONTEXT_TYPE ContextType);
VOID AriadInstanceTeardownComplete(__in PCFLT_RELATED_OBJECTS FltObjects, __in FLT_INSTANCE_TEARDOWN_FLAGS Flags);

#endif /* __ARIAD_H__ */
